10 REM ================================
11 REM == MICROPAC 515C TEST PROGRAM ===
12 REM ================================



40 UI0:UO0 : REM DEFAULT TO COM 0
45 ? CHR(26),  : REM   CLEAR SCREEN
47 ? " MICROPAC 515C TEST Ver. 0":?

50 ? " 1 -- A/D TEST"
60 ? " 2 -- COM1 I/O"
70 ? " 3 -- COM2 I/O"
80 ? " 4 -- KEYPAD INPUT"
90 ? " 5 -- LCD OUTPUT"
100? " 6 -- DIGITAL PORTS (PX0 TO PX18)"
110? " 7 -- D/A TEST"
120? " 8 -- SEEPROM TEST"

200 X=GET
202 IF X=0 THEN 200
210 IF X < 49 .OR. X>56 THEN 40  : REM  RE-ENTER IF NOT 1 TO 7



220 X=X-49
230 ON X GOSUB 1000,2000,3000,4000,5000,6000,7000,8000





240 GOTO 40: REM  KEEP SPACES BETWEEN ON X GOSUB AND HERE FOR DOWNLOAD




1000 REM ==============
1001 REM == A/D TEST ==
1002 REM ==============
1010 ?
1030 FOR A1=10 TO 17
1040 PH0. ADCIN(A1),
1050 NEXT A1
1070 FOR A2=1 TO 20:NEXT A2 : REM WAIT 
1080 IF GET=0 THEN 1010
1090 RETURN

2000 REM ====================
2001 REM ==   COM1 TEST    ==
2002 REM ====================
2003 ?:? " COM1 TEST.  PRESS SOME KEYS AND PRESS ENTER TO EXIT"
2005 FOR A2=0 TO 1000: NEXT A2 : REM   DELAY

2010 UI1:UO1 
2020  X1=GET
2022 IF X1=0 THEN 2020
2024 IF X1=13 THEN 2032
2030 ?CHR(X1),
2031 GOTO 2020
2032 ?:? "MOVE CONNECTOR TO COM0"
2035 FOR A2=0 TO 1000: NEXT A2 : REM   DELAY
2040 RETURN


3000 REM ====================
3001 REM ==   COM2 TEST    ==
3002 REM ====================
3003 ?:? " COM2 TEST.  PRESS SOME KEYS AND PRESS ENTER TO EXIT"
3005 FOR A2=0 TO 1000: NEXT A2 : REM   DELAY

3010 UI2:UO2 
3020  X2=GET
3022 IF X2=0 THEN 3020
3024 IF X2=13 THEN 3032
3030 ?CHR(X2),
3031 GOTO 3020
3032 ?:? "MOVE CONNECTOR TO COM0"
3035 FOR A2=0 TO 1000: NEXT A2 : REM   DELAY
3040 RETURN

4000 REM ====================
4001 REM ==  KEYPAD TEST   ==
4002 REM ====================
4003 ?:?"KEYPAD TEST. PRESS 7 TO EXIT"
4010 UI3
4020 X=GET
4030 IF X=037H THEN RETURN
4035 IF X=0 THEN 4020
4040 ? CHR(X),
4050 GOTO 4010


5000 REM ====================
5001 REM ==    LCD TEST    ==
5002 REM ====================
5003 ?:? "LCD TEST "
5010 UO6
5020 ? CHR(26)," LCD OUTPUT TEST"
5025 FOR A2=0 TO 1000: NEXT A2 : REM   DELAY
5030 ? " THIS IS LINE 2"
5040 RETURN

6000 REM ======================
6001 REM == DIGITAL I/O TEST ==
6002 REM ======================

6005 ?:? " DIGITAL I/O TEST.  PRESS A KEY TO EXIT"
6006 SFR(0F8H)=SFR(0F8H) .OR. 2  :REM DISABLE MMIO SINCE XBY INVERTS THE MMIO CONTROL BIT
6010 FOR X=0 TO 255
6020 PORT1=X
6030 SFR(0B0H)=X .OR. 0C7H  :REM   11000111B
6040 XBY(4000h)=X       :REM   WRITE  TO PX0-PX7
6050 NEXT X
6060 IF GET=0 THEN 6010

6100 ? " ALTERNATING BITS "
6107 X=0AAH
6110 IF X=0AAH THEN X=055H:GOTO 6120
6115 IF X=055H THEN X=0AAH
6120 PORT1=X
6130 SFR(0B0H)=X .OR. 0C7H  :REM   11000111B
6140 XBY(4000h)=X       :REM   WRITE  TO PX0-PX7
6160 IF GET=0 THEN 6110

6200 ? " WALKING BITS "
6210 X=0.5
6220 X=X*2
6230 PORT1=X
6240 SFR(0B0H)=X .OR. 0C7H  :REM   11000111B
6250 XBY(4000h)=X       :REM   WRITE  TO PX0-PX7
6260 FOR X1=1 TO 150:NEXT X1
6270 IF X=128 THEN 6210
6280 IF GET=0 THEN 6220
6290 RETURN


7000 REM ==============
7001 REM == D/A TEST ==
7003 REM ==============
7005 ?:? " D/A TEST" 
7010 FOR A1=0 TO 3
7020 FOR X=0 TO 255
7030 DACOUT(A1)=X
7040 NEXT X
7050 NEXT A1
7060 IF GET THEN RETURN
7080 GOTO 7010


8000 REM ========================
8006 REM = SEEPROM TEST ROUTINE =
8007 REM ========================
8008 ER=0
8010 IF EEPROM(0) THEN ? "DATA OK" ELSE ? "CRC ERROR OR UNTESTED"
8020  FOR X= 1 TO 63
8025 ? "W",
8030 EEPROM(X)=(63-X) + X*256
8040 NEXT X
8045 ?
8050 FOR X= 1 TO 63
8055 ?"R",
8060 IF EEPROM(X)<>(63-X) + X*256 THEN ER=1
8070 NEXT X
8075 ?
8080 IF ER=1 THEN ?"...........SEEPROM ERROR" ELSE ? " OKAY "
8090 RETURN

